module test_top( clk50, 
                    Ethernet_TDp, Ethernet_TDn, Ethernet_RDp, Ethernet_RDn, 
						  test_out,  ARP, 
						  //Data_In, 
						  //data, 
						  //SS, CC,
						  RxD, TxD, 
						  new_byte_available,
						  write
						  );

input  clk50, ARP, Ethernet_RDp, Ethernet_RDn;
//input [7:0] Data_In;
input write;
input RxD;
output TxD; 
//input SS, CC;
output Ethernet_TDp, Ethernet_TDn, test_out, new_byte_available;
//output [7:0] data;

wire SS;
wire [7:0] test_data;
wire [7:0] eth_tx_intermediate;
wire [7:0] eth_rx_intermediate;
wire [7:0] Uart_tx_intermediate;
wire [7:0] Uart_rx_intermediate;
wire reset=1'b0;

//-----------------------------------------------------------------------------------------
clkgenerator Inst_dcm1      ( .clk50(clk50), .clk20(clk20), .clk80(clk80), .clk160(clk160), .clkUART(clkUART));
IBUFDS_LVDS_25 UI1          ( .I(Ethernet_RDp), .IB(Ethernet_RDn), .O(manchester_data_in)); 
test_module test1           ( .test_clk(clk80), .test_out(test_out), 
                              .StartSending(), .test_data(test_data));
//------------------------------------------------------------------------------------------ 
async_rx My_Uart_Rx         ( .clk(clk160), .RxD(RxD), .RxD_data_ready(RxD_data_ready), 
                              .RxD_data(Uart_rx_intermediate),
                              .RxD_endofpacket(), .RxD_idle());

FIFO_128 MY_fifo_tx         ( .clk(clk20),
                              .data_in(Uart_rx_intermediate), .data_out(eth_tx_intermediate), 
							         .write(RxD_data_ready), .read(read), .reset(reset),
                              .full(), .half_full(StartSending), .data_present());

eth_ip_udp  My_eth_ip_udp   ( .clk20(clk20), .Ethernet_TDp(Ethernet_TDp), .Ethernet_TDn(Ethernet_TDn),
                              .Data_In(eth_tx_intermediate), .ARP(ARP), .StartSending(StartSending),
										.readram(read));
//----------------------------------------------------------------------------------------------
tenbasetrxd My_tenbasetrxd  ( .clk80(clk80), .manchester_data_in(manchester_data_in), 
                              .data(eth_rx_intermediate), 
                              .new_byte_available(new_byte_available));

FIFO_128 MY_fifo_rx         ( .clk(clk20),
                              .data_in(eth_rx_intermediate), .data_out(Uart_tx_intermediate), 
							         .write(new_byte_available), .read(busy), .reset(reset),
                              .full(), .half_full(), .data_present(start));

async_tx My_Uart_Tx         ( .clk(clk160), .TxD_start(start), .TxD_data(Uart_tx_intermediate), 
                              .TxD(TxD), .TxD_busy(busy));


endmodule